# coding: utf-8


"""
IGNORE:
    Nutanix Networking APIs

    Manage networking configuration on Nutanix clusters, including AHV and advanced networking.  # noqa: E501

    OpenAPI spec version: 4.1.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_networking_py_client.models.common.v1.config.Metadata import Metadata  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.CapabilityConfig import CapabilityConfig  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.HostNicReference import HostNicReference  # noqa: F401,E501
from ntnx_networking_py_client.models.networking.v4.config.NetworkingBaseModel import NetworkingBaseModel  # noqa: F401,E501

class NicProfile(NetworkingBaseModel):

    """

    :param name: (:attr:`name`) Name of the NIC Profile.
    :type name: required
     max=128 chars
    
    :param description: (:attr:`description`) Description of the NIC Profile.
    :type description: 
     max=1000 chars
    
    :param capability_config: (:attr:`capability_config`) 
    :type capability_config: required
    
    
    :param host_nic_references: (:attr:`host_nic_references`) List of host NICs references associated with the NIC Profile.
    :type host_nic_references: 
    
    
    :param nic_family: (:attr:`nic_family`) Specification for a specific device family of Host NIC. The given string must be in the format vendor_id:device_id.
    :type nic_family: required
     max=256 chars
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'capability_config': 'networking.v4.config.CapabilityConfig',
        'host_nic_references': 'list[networking.v4.config.HostNicReference]',
        'nic_family': 'str',
        'metadata': 'common.v1.config.Metadata',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'capability_config': 'capabilityConfig',
        'host_nic_references': 'hostNicReferences',
        'nic_family': 'nicFamily',
        'metadata': 'metadata',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, name=None, description=None, capability_config=None, host_nic_references=None, nic_family=None, metadata=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        NetworkingBaseModel.__init__(self, metadata, ext_id, links, tenant_id, *args, **kwargs)
        self.__name = None
        self.__description = None
        self.__capability_config = None
        self.__host_nic_references = None
        self.__nic_family = None
        self.discriminator = None
        self.__name = name
        if description is not None:
            self.__description = description
        self.__capability_config = capability_config
        if host_nic_references is not None:
            self.__host_nic_references = host_nic_references
        self.__nic_family = nic_family

    def _initialize_object_type(self):
        return 'networking.v4.config.NicProfile'

    def _initialize_object_version(self):
        return 'v4.r1'


    @property
    def name(self):
        """
        Name of the NIC Profile.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__name

    @name.setter
    def name(self, name):
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if name is not None and len(name) > 128:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `128`")  # noqa: E501

        self.__name = name

    @property
    def description(self):
        """
        Description of the NIC Profile.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__description

    @description.setter
    def description(self, description):
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501

        self.__description = description

    @property
    def capability_config(self):
        """
        

        :type:
            :class:`~ntnx_networking_py_client.models.networking.v4.config.CapabilityConfig`
        """  # noqa: E501
        return self.__capability_config

    @capability_config.setter
    def capability_config(self, capability_config):
        if capability_config is None:
            raise ValueError("Invalid value for `capability_config`, must not be `None`")  # noqa: E501

        self.__capability_config = capability_config

    @property
    def host_nic_references(self):
        """
        List of host NICs references associated with the NIC Profile.

        :type:
             list[ :class:`~ntnx_networking_py_client.models.networking.v4.config.HostNicReference` ]
        """  # noqa: E501
        return self.__host_nic_references

    @host_nic_references.setter
    def host_nic_references(self, host_nic_references):

        self.__host_nic_references = host_nic_references

    @property
    def nic_family(self):
        """
        Specification for a specific device family of Host NIC. The given string must be in the format vendor_id:device_id.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__nic_family

    @nic_family.setter
    def nic_family(self, nic_family):
        if nic_family is None:
            raise ValueError("Invalid value for `nic_family`, must not be `None`")  # noqa: E501
        if nic_family is not None and len(nic_family) > 256:
            raise ValueError("Invalid value for `nic_family`, length must be less than or equal to `256`")  # noqa: E501

        self.__nic_family = nic_family

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(NicProfile, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NicProfile):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

